summaryrefslogtreecommitdiff
path: root/tests/tail-2/F-vs-missing.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-08-30 14:13:12 +0200
committerJim Meyering <meyering@redhat.com>2012-08-30 18:55:59 +0200
commit9eb4c31eb78c28dd9f72d1cbb940270311be343c (patch)
treeea3078bc1b002a9f948ed41445ca32318002a1d3 /tests/tail-2/F-vs-missing.sh
parent00f5ba15dd91a3d9780fe1fbd06a4df436ae6714 (diff)
downloadcoreutils-9eb4c31eb78c28dd9f72d1cbb940270311be343c.tar.xz
tests: add .sh and .pl suffixes to shell and perl tests, respectively
Not only this shrinks the size of the generated Makefile (from > 6300 lines to ~3000), but will allow further simplifications in future changes. * tests/Makefile.am (TEST_EXTENSIONS): Add '.sh' and '.pl'. (PL_LOG_COMPILER, SH_LOG_COMPILER): New, still defined simply to $(LOG_COMPILER) for the time being. (TESTS, root_tests): Adjust as described. * All tests: Rename as described.
Diffstat (limited to 'tests/tail-2/F-vs-missing.sh')
-rwxr-xr-xtests/tail-2/F-vs-missing.sh64
1 files changed, 64 insertions, 0 deletions
diff --git a/tests/tail-2/F-vs-missing.sh b/tests/tail-2/F-vs-missing.sh
new file mode 100755
index 000000000..fbdb53314
--- /dev/null
+++ b/tests/tail-2/F-vs-missing.sh
@@ -0,0 +1,64 @@
+#!/bin/sh
+# demonstrate that tail -F works for currently missing dirs
+# Before coreutils-8.6, tail -F missing/file would not
+# notice any subsequent availability of the missing/file.
+
+# Copyright (C) 2010-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ tail
+
+debug='---disable-inotify'
+debug=
+tail $debug -F -s.1 missing/file > out 2>&1 & pid=$!
+
+check_tail_output()
+{
+ local delay="$1"
+ grep "$tail_re" out > /dev/null ||
+ { sleep $delay; return 1; }
+}
+
+# Wait up to 6.3s for tail to start with diagnostic:
+# tail: cannot open 'missing/file' for reading: No such file or directory
+tail_re='cannot open' retry_delay_ check_tail_output .1 7 || fail=1
+
+mkdir missing || fail=1
+(cd missing && echo x > file)
+
+# Wait up to 6.3s for this to appear in the output:
+# "tail: '...' has appeared; following end of new file"
+tail_re='has appeared' retry_delay_ check_tail_output .1 7 ||
+ { echo "$0: file: unexpected delay?"; cat out; fail=1; }
+
+kill -HUP $pid
+
+cleanup()
+{
+ local delay="$1"
+ rm -rf missing ||
+ { sleep $delay; return 1; }
+}
+
+# Try repeatedly to remove the temporary directory.
+# This is normally unnecessary, because the containing directory will
+# be removed by code from init.sh. However, when this particular test
+# is run on an NFS-mounted volume, sometimes init.sh's cleanup code
+# fails because the directory is not yet really empty, perhaps because
+# the tail process (reading missing/file) is not yet killed.
+retry_delay_ cleanup .1 6
+
+Exit $fail